Index: connector/src/main/org/jboss/resource/adapter/jdbc/WrapperDataSource.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/WrapperDataSource.java	(revision 112935)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/WrapperDataSource.java	(working copy)
@@ -21,10 +21,9 @@
  */
 package org.jboss.resource.adapter.jdbc;
 
-import java.io.PrintWriter;
-import java.io.Serializable;
-import java.sql.Connection;
-import java.sql.SQLException;
+import org.jboss.resource.connectionmanager.JTATransactionChecker;
+import org.jboss.tm.TransactionTimeoutConfiguration;
+import org.jboss.util.NestedSQLException;
 
 import javax.naming.Reference;
 import javax.resource.Referenceable;
@@ -33,11 +32,13 @@
 import javax.resource.spi.ConnectionRequestInfo;
 import javax.sql.DataSource;
 import javax.transaction.RollbackException;
+import java.io.PrintWriter;
+import java.io.Serializable;
+import java.sql.Connection;
+import java.sql.SQLException;
+import java.sql.SQLFeatureNotSupportedException;
+import java.util.logging.Logger;
 
-import org.jboss.resource.connectionmanager.JTATransactionChecker;
-import org.jboss.tm.TransactionTimeoutConfiguration;
-import org.jboss.util.NestedSQLException;
-
 /**
  * WrapperDataSource
  *
@@ -77,6 +78,12 @@
       return 0;
    }
 
+   public Logger getParentLogger() throws SQLFeatureNotSupportedException
+   {
+      // SQLFeatureNotSupportedException is not available in JDK 5
+      throw new SQLFeatureNotSupportedException("NYI: org.jboss.resource.adapter.jdbc.WrapperDataSource.getParentLogger");
+   }
+
    public void setLoginTimeout(int param1) throws SQLException
    {
       // TODO: implement this javax.sql.DataSource method
Index: connector/src/main/org/jboss/resource/adapter/jdbc/CachedCallableStatement.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/CachedCallableStatement.java	(revision 112935)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/CachedCallableStatement.java	(working copy)
@@ -48,7 +48,7 @@
 public abstract class CachedCallableStatement extends CachedPreparedStatement
    implements CallableStatement
 {
-   private final CallableStatement cs;
+   protected final CallableStatement cs;
 
    public CachedCallableStatement(CallableStatement ps) throws SQLException
    {
@@ -453,6 +453,7 @@
       cs.setTimestamp(parameterName, x, cal);
    }
 
+   @Deprecated
    protected CallableStatement getWrappedObject() throws SQLException
    {
       return cs;
Index: connector/src/main/org/jboss/resource/adapter/jdbc/CachedPreparedStatement.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/CachedPreparedStatement.java	(revision 112935)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/CachedPreparedStatement.java	(working copy)
@@ -49,7 +49,7 @@
 {
    private static final long serialVersionUID = 2085461257386274373L;
    
-   private PreparedStatement ps;
+   protected final PreparedStatement ps;
    private AtomicBoolean cached = new AtomicBoolean(true);
    private AtomicInteger inUse = new AtomicInteger(1);
 
@@ -526,6 +526,7 @@
       return ps.getResultSetHoldability();
    }
 
+   @Deprecated
    protected PreparedStatement getWrappedObject() throws SQLException
    {
       return ps;
Index: connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/WrappedResultSetJDBC4_1.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/WrappedResultSetJDBC4_1.java	(revision 0)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/WrappedResultSetJDBC4_1.java	(revision 0)
@@ -0,0 +1,65 @@
+/*
+ * JBoss, Home of Professional Open Source.
+ * Copyright (c) 2012, Red Hat, Inc., and individual contributors
+ * as indicated by the @author tags. See the copyright.txt file in the
+ * distribution for a full listing of individual contributors.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.jboss.resource.adapter.jdbc.jdbc4_1;
+
+import org.jboss.resource.adapter.jdbc.WrappedStatement;
+import org.jboss.resource.adapter.jdbc.jdbc4.WrappedResultSetJDBC4;
+
+import java.sql.ResultSet;
+import java.sql.SQLException;
+
+/**
+ * @author <a href="mailto:cdewolf@redhat.com">Carlo de Wolf</a>
+ */
+public abstract class WrappedResultSetJDBC4_1 extends WrappedResultSetJDBC4
+{
+   protected WrappedResultSetJDBC4_1(WrappedStatement statement, ResultSet resultSet)
+   {
+      super(statement, resultSet);
+   }
+
+   @Override
+   public <T> T getObject(int columnIndex, Class<T> type) throws SQLException
+   {
+      try
+      {
+         return getUnderlyingResultSet().getObject(columnIndex, type);
+      }
+      catch (Throwable t)
+      {
+         throw checkException(t);
+      }
+   }
+
+   @Override
+   public <T> T getObject(String columnLabel, Class<T> type) throws SQLException
+   {
+      try
+      {
+         return getUnderlyingResultSet().getObject(columnLabel, type);
+      }
+      catch (Throwable t)
+      {
+         throw checkException(t);
+      }
+   }
+}
Index: connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/CachedPreparedStatementJDBC4_1.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/CachedPreparedStatementJDBC4_1.java	(revision 0)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/CachedPreparedStatementJDBC4_1.java	(revision 0)
@@ -0,0 +1,50 @@
+/*
+ * JBoss, Home of Professional Open Source.
+ * Copyright (c) 2012, Red Hat, Inc., and individual contributors
+ * as indicated by the @author tags. See the copyright.txt file in the
+ * distribution for a full listing of individual contributors.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.jboss.resource.adapter.jdbc.jdbc4_1;
+
+import org.jboss.resource.adapter.jdbc.jdbc4.CachedPreparedStatementJDBC4;
+
+import java.sql.PreparedStatement;
+import java.sql.SQLException;
+
+/**
+ * @author <a href="mailto:cdewolf@redhat.com">Carlo de Wolf</a>
+ */
+public abstract class CachedPreparedStatementJDBC4_1 extends CachedPreparedStatementJDBC4
+{
+   protected CachedPreparedStatementJDBC4_1(PreparedStatement ps) throws SQLException
+   {
+      super(ps);
+   }
+
+   @Override
+   public void closeOnCompletion() throws SQLException
+   {
+      ps.closeOnCompletion();
+   }
+
+   @Override
+   public boolean isCloseOnCompletion() throws SQLException
+   {
+      return ps.isCloseOnCompletion();
+   }
+}
Index: connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/WrappedConnectionJDBC4_1.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/WrappedConnectionJDBC4_1.java	(revision 0)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/WrappedConnectionJDBC4_1.java	(revision 0)
@@ -0,0 +1,129 @@
+/*
+ * JBoss, Home of Professional Open Source.
+ * Copyright (c) 2012, Red Hat, Inc., and individual contributors
+ * as indicated by the @author tags. See the copyright.txt file in the
+ * distribution for a full listing of individual contributors.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.jboss.resource.adapter.jdbc.jdbc4_1;
+
+import org.jboss.resource.adapter.jdbc.BaseWrapperManagedConnection;
+import org.jboss.resource.adapter.jdbc.jdbc4.WrappedConnectionJDBC4;
+
+import java.sql.SQLException;
+import java.util.concurrent.Executor;
+
+/**
+ * @author <a href="mailto:cdewolf@redhat.com">Carlo de Wolf</a>
+ */
+public abstract class WrappedConnectionJDBC4_1 extends WrappedConnectionJDBC4
+{
+   protected WrappedConnectionJDBC4_1(BaseWrapperManagedConnection mc)
+   {
+      super(mc);
+   }
+
+   @Override
+   public void setSchema(String schema) throws SQLException
+   {
+      lock();
+      try
+      {
+         getUnderlyingConnection().setSchema(schema);
+      }
+      catch (Throwable t)
+      {
+         throw checkException(t);
+      }
+      finally
+      {
+         unlock();
+      }
+   }
+
+   @Override
+   public String getSchema() throws SQLException
+   {
+      lock();
+      try
+      {
+         return getUnderlyingConnection().getSchema();
+      }
+      catch (Throwable t)
+      {
+         throw checkException(t);
+      }
+      finally
+      {
+         unlock();
+      }
+   }
+
+   @Override
+   public void abort(Executor executor) throws SQLException
+   {
+      lock();
+      try
+      {
+         getUnderlyingConnection().abort(executor);
+      }
+      catch (Throwable t)
+      {
+         throw checkException(t);
+      }
+      finally
+      {
+         unlock();
+      }
+   }
+
+   @Override
+   public void setNetworkTimeout(Executor executor, int milliseconds) throws SQLException
+   {
+      lock();
+      try
+      {
+         getUnderlyingConnection().setNetworkTimeout(executor, milliseconds);
+      }
+      catch (Throwable t)
+      {
+         throw checkException(t);
+      }
+      finally
+      {
+         unlock();
+      }
+   }
+
+   @Override
+   public int getNetworkTimeout() throws SQLException
+   {
+      lock();
+      try
+      {
+         return getUnderlyingConnection().getNetworkTimeout();
+      }
+      catch (Throwable t)
+      {
+         throw checkException(t);
+      }
+      finally
+      {
+         unlock();
+      }
+   }
+}
Index: connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/WrappedCallableStatementJDBC4_1.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/WrappedCallableStatementJDBC4_1.java	(revision 0)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/WrappedCallableStatementJDBC4_1.java	(revision 0)
@@ -0,0 +1,95 @@
+/*
+ * JBoss, Home of Professional Open Source.
+ * Copyright (c) 2012, Red Hat, Inc., and individual contributors
+ * as indicated by the @author tags. See the copyright.txt file in the
+ * distribution for a full listing of individual contributors.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.jboss.resource.adapter.jdbc.jdbc4_1;
+
+import org.jboss.resource.adapter.jdbc.jdbc4.WrappedCallableStatementJDBC4;
+import org.jboss.resource.adapter.jdbc.jdbc4.WrappedConnectionJDBC4;
+
+import java.sql.CallableStatement;
+import java.sql.SQLException;
+
+/**
+ * @author <a href="mailto:cdewolf@redhat.com">Carlo de Wolf</a>
+ */
+public abstract class WrappedCallableStatementJDBC4_1 extends WrappedCallableStatementJDBC4
+{
+   protected WrappedCallableStatementJDBC4_1(WrappedConnectionJDBC4 lc, CallableStatement s)
+   {
+      super(lc, s);
+   }
+
+   @Override
+   public <T> T getObject(int parameterIndex, Class<T> type) throws SQLException
+   {
+      final CallableStatement statement = getUnderlyingStatement();
+      try
+      {
+         return statement.getObject(parameterIndex, type);
+      }
+      catch (Throwable t)
+      {
+         throw checkException(t);
+      }
+   }
+
+   @Override
+   public <T> T getObject(String parameterName, Class<T> type) throws SQLException
+   {
+      final CallableStatement statement = getUnderlyingStatement();
+      try
+      {
+         return statement.getObject(parameterName, type);
+      }
+      catch (Throwable t)
+      {
+         throw checkException(t);
+      }
+   }
+
+   @Override
+   public void closeOnCompletion() throws SQLException
+   {
+      final CallableStatement statement = getUnderlyingStatement();
+      try
+      {
+         statement.closeOnCompletion();
+      }
+      catch (Throwable t)
+      {
+         throw checkException(t);
+      }
+   }
+
+   @Override
+   public boolean isCloseOnCompletion() throws SQLException
+   {
+      final CallableStatement statement = getUnderlyingStatement();
+      try
+      {
+         return statement.isCloseOnCompletion();
+      }
+      catch (Throwable t)
+      {
+         throw checkException(t);
+      }
+   }
+}
Index: connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/WrappedStatementJDBC4_1.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/WrappedStatementJDBC4_1.java	(revision 0)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/WrappedStatementJDBC4_1.java	(revision 0)
@@ -0,0 +1,67 @@
+/*
+ * JBoss, Home of Professional Open Source.
+ * Copyright (c) 2012, Red Hat, Inc., and individual contributors
+ * as indicated by the @author tags. See the copyright.txt file in the
+ * distribution for a full listing of individual contributors.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.jboss.resource.adapter.jdbc.jdbc4_1;
+
+import org.jboss.resource.adapter.jdbc.jdbc4.WrappedConnectionJDBC4;
+import org.jboss.resource.adapter.jdbc.jdbc4.WrappedStatementJDBC4;
+
+import java.sql.SQLException;
+import java.sql.Statement;
+
+/**
+ * @author <a href="mailto:cdewolf@redhat.com">Carlo de Wolf</a>
+ */
+public abstract class WrappedStatementJDBC4_1 extends WrappedStatementJDBC4
+{
+   protected WrappedStatementJDBC4_1(WrappedConnectionJDBC4 lc, Statement s)
+   {
+      super(lc, s);
+   }
+
+   @Override
+   public void closeOnCompletion() throws SQLException
+   {
+      final Statement statement = getUnderlyingStatement();
+      try
+      {
+         statement.closeOnCompletion();
+      }
+      catch (Throwable t)
+      {
+         throw checkException(t);
+      }
+   }
+
+   @Override
+   public boolean isCloseOnCompletion() throws SQLException
+   {
+      final Statement statement = getUnderlyingStatement();
+      try
+      {
+         return statement.isCloseOnCompletion();
+      }
+      catch (Throwable t)
+      {
+         throw checkException(t);
+      }
+   }
+}
Index: connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/WrappedPreparedStatementJDBC4_1.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/WrappedPreparedStatementJDBC4_1.java	(revision 0)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/WrappedPreparedStatementJDBC4_1.java	(revision 0)
@@ -0,0 +1,75 @@
+/*
+ * JBoss, Home of Professional Open Source.
+ * Copyright (c) 2012, Red Hat, Inc., and individual contributors
+ * as indicated by the @author tags. See the copyright.txt file in the
+ * distribution for a full listing of individual contributors.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.jboss.resource.adapter.jdbc.jdbc4_1;
+
+import org.jboss.resource.adapter.jdbc.jdbc4.WrappedConnectionJDBC4;
+import org.jboss.resource.adapter.jdbc.jdbc4.WrappedPreparedStatementJDBC4;
+
+import java.sql.PreparedStatement;
+import java.sql.SQLException;
+
+/**
+ * @author <a href="mailto:cdewolf@redhat.com">Carlo de Wolf</a>
+ */
+public abstract class WrappedPreparedStatementJDBC4_1 extends WrappedPreparedStatementJDBC4
+{
+   protected WrappedPreparedStatementJDBC4_1(WrappedConnectionJDBC4 lc, PreparedStatement s)
+   {
+      super(lc, s);
+   }
+
+   @Override
+   public void closeOnCompletion() throws SQLException
+   {
+      lock();
+      try
+      {
+         getUnderlyingStatement().closeOnCompletion();
+      }
+      catch (Throwable t)
+      {
+         throw checkException(t);
+      }
+      finally
+      {
+         unlock();
+      }
+   }
+
+   @Override
+   public boolean isCloseOnCompletion() throws SQLException
+   {
+      lock();
+      try
+      {
+         return getUnderlyingStatement().isCloseOnCompletion();
+      }
+      catch (Throwable t)
+      {
+         throw checkException(t);
+      }
+      finally
+      {
+         unlock();
+      }
+   }
+}
Index: connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/CachedCallableStatementJDBC4_1.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/CachedCallableStatementJDBC4_1.java	(revision 0)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4_1/CachedCallableStatementJDBC4_1.java	(revision 0)
@@ -0,0 +1,62 @@
+/*
+ * JBoss, Home of Professional Open Source.
+ * Copyright (c) 2012, Red Hat, Inc., and individual contributors
+ * as indicated by the @author tags. See the copyright.txt file in the
+ * distribution for a full listing of individual contributors.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.jboss.resource.adapter.jdbc.jdbc4_1;
+
+import org.jboss.resource.adapter.jdbc.jdbc4.CachedCallableStatementJDBC4;
+
+import java.sql.CallableStatement;
+import java.sql.SQLException;
+
+/**
+ * @author <a href="mailto:cdewolf@redhat.com">Carlo de Wolf</a>
+ */
+public abstract class CachedCallableStatementJDBC4_1 extends CachedCallableStatementJDBC4
+{
+   protected CachedCallableStatementJDBC4_1(CallableStatement cs) throws SQLException
+   {
+      super(cs);
+   }
+
+   @Override
+   public <T> T getObject(int parameterIndex, Class<T> type) throws SQLException
+   {
+      return cs.getObject(parameterIndex, type);
+   }
+
+   @Override
+   public <T> T getObject(String parameterName, Class<T> type) throws SQLException
+   {
+      return cs.getObject(parameterName, type);
+   }
+
+   @Override
+   public void closeOnCompletion() throws SQLException
+   {
+      cs.closeOnCompletion();
+   }
+
+   @Override
+   public boolean isCloseOnCompletion() throws SQLException
+   {
+      return cs.isCloseOnCompletion();
+   }
+}
Index: tools/etc/buildmagic/buildmagic.ent
===================================================================
--- tools/etc/buildmagic/buildmagic.ent	(revision 112935)
+++ tools/etc/buildmagic/buildmagic.ent	(working copy)
@@ -32,11 +32,30 @@
   <available classname="java.lang.StackTraceElement" property="HAVE_JDK_1.4"/>
   <available classname="java.lang.Enum" property="HAVE_JDK_1.5"/>
   <available classname="java.lang.management.LockInfo" property="HAVE_JDK_1.6"/>  
-  
+  <available classname="java.util.concurrent.ForkJoinPool" property="HAVE_JDK_1.7"/>
+
   <fail unless="HAVE_JDK_1.5">
   Unsupported Java version: You need at least JDK5 to build JBoss5
   </fail>
 
+  <echo message="ant.java.version = ${ant.java.version}"/>
+  <condition property="IS_JDK_1.5">
+    <and><equals arg1="${ant.java.version}" arg2="1.5"/></and>
+  </condition>
+  <condition property="IS_JDK_1.6">
+    <and>
+      <equals arg1="${ant.java.version}" arg2="1.6"/>
+      <!-- current Ant version in buildmagic does not detect JDK 7 -->
+      <not><isset property="HAVE_JDK_1.7"/></not>
+    </and>
+  </condition>
+  <condition property="IS_JDK_1.7">
+    <!-- current Ant version in buildmagic does not detect JDK 7
+    <and><equals arg1="${ant.java.version}" arg2="1.7"/></and>
+    -->
+    <isset property="HAVE_JDK_1.7"/>
+  </condition>
+
   <!-- Setup the project environment. -->
   <dirname property="project.root" file="${basedir}"/>
   <property name="project.build" value="${project.root}/build"/>
Index: varia/src/main/org/jboss/varia/stats/AbstractDataSourceInterceptorJDBC4_1.java
===================================================================
--- varia/src/main/org/jboss/varia/stats/AbstractDataSourceInterceptorJDBC4_1.java	(revision 0)
+++ varia/src/main/org/jboss/varia/stats/AbstractDataSourceInterceptorJDBC4_1.java	(revision 0)
@@ -0,0 +1,113 @@
+/*
+ * JBoss, Home of Professional Open Source.
+ * Copyright (c) 2012, Red Hat, Inc., and individual contributors
+ * as indicated by the @author tags. See the copyright.txt file in the
+ * distribution for a full listing of individual contributors.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.jboss.varia.stats;
+
+import java.sql.Connection;
+import java.sql.PreparedStatement;
+import java.sql.SQLException;
+import java.sql.SQLFeatureNotSupportedException;
+import java.sql.Statement;
+import java.util.concurrent.Executor;
+import java.util.logging.Logger;
+
+/**
+ * @author <a href="mailto:cdewolf@redhat.com">Carlo de Wolf</a>
+ */
+abstract class AbstractDataSourceInterceptorJDBC4_1 extends AbstractDataSourceInterceptorJDBC4
+{
+   public Logger getParentLogger() throws SQLFeatureNotSupportedException
+   {
+      return target.getParentLogger();
+   }
+
+   // Inner
+
+   protected abstract class ConnectionInterceptor extends AbstractDataSourceInterceptorJDBC4.ConnectionInterceptor
+   {
+      protected ConnectionInterceptor(Connection target)
+      {
+         super(target);
+      }
+
+      public void setSchema(String schema) throws SQLException
+      {
+         target.setSchema(schema);
+      }
+
+      public String getSchema() throws SQLException
+      {
+         return target.getSchema();
+      }
+
+      public void abort(Executor executor) throws SQLException
+      {
+         target.abort(executor);
+      }
+
+      public void setNetworkTimeout(Executor executor, int milliseconds) throws SQLException
+      {
+         target.setNetworkTimeout(executor, milliseconds);
+      }
+
+      public int getNetworkTimeout() throws SQLException
+      {
+         return target.getNetworkTimeout();
+      }
+   }
+
+   protected abstract class StatementInterceptor extends AbstractDataSourceInterceptorJDBC4.StatementInterceptor
+   {
+      protected StatementInterceptor(Connection con, Statement target)
+      {
+         super(con, target);
+      }
+
+      public void closeOnCompletion() throws SQLException
+      {
+         target.closeOnCompletion();
+      }
+
+      public boolean isCloseOnCompletion() throws SQLException
+      {
+         return target.isCloseOnCompletion();
+      }
+   }
+
+   protected abstract class PreparedStatementInterceptor extends AbstractDataSourceInterceptorJDBC4.PreparedStatementInterceptor
+           implements PreparedStatement
+   {
+      public PreparedStatementInterceptor(Connection con, PreparedStatement target)
+      {
+         super(con, target);
+      }
+
+      public void closeOnCompletion() throws SQLException
+      {
+         target.closeOnCompletion();
+      }
+
+      public boolean isCloseOnCompletion() throws SQLException
+      {
+         return target.isCloseOnCompletion();
+      }
+   }
+}
